OpenJPH: ojph::local::visual_weights Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::visual_weights Class Reference

## Public Types
enum | colour_format : ui32 { VW_COLOUR_FORMAT_400 = 0 , VW_COLOUR_FORMAT_420 = 1 , VW_COLOUR_FORMAT_422 = 2 , VW_COLOUR_FORMAT_444 = 3 , VW_COLOUR_FORMAT_ERROR = 4 }
using | comp_type = param_qcd::comp_type

## Static Public Member Functions
static colour_format | get_format (const point &component_subsampling)
static const float * | get_weights (ui32 format, ui32 comp_type)
static const float * | get_no_weights ()
static float | get_weight (const float *v, ui32 decomposition_level, ui32 subband_idx)
static float | get_gain (ui32 comp_type)
static float | get_delta_ref (ui32 qfactor, ui32 bit_depth, float &power)

## Static Private Attributes
static const float | cb420 [19]
static const float | cr420 [19]
static const float | cb422 [19]
static const float | cr422 [19]
static const float | cb444 [19]
static const float | cr444 [19]
static const float | y [19]
static const float | no_weights [19]

## Detailed Description

Definition at line 599 of file ojph_params.cpp.

## Member Typedef Documentation

## ◆ comp_type

using ojph::local::visual_weights::comp_type = param_qcd::comp_type

Definition at line 610 of file ojph_params.cpp.

## Member Enumeration Documentation

## ◆ colour_format

enum ojph::local::visual_weights::colour_format : ui32

Enumerator
VW_COLOUR_FORMAT_400 |
VW_COLOUR_FORMAT_420 |
VW_COLOUR_FORMAT_422 |
VW_COLOUR_FORMAT_444 |
VW_COLOUR_FORMAT_ERROR |

Definition at line 602 of file ojph_params.cpp.

## Member Function Documentation

## ◆ get_delta_ref()

float ojph::local::visual_weights::get_delta_ref | ( | ui32 | qfactor,
|  | ui32 | bit_depth,
|  | float & | power )
| inlinestatic

Definition at line 690 of file ojph_params.cpp.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## ◆ get_format()

colour_format ojph::local::visual_weights::get_format | ( | const point & | component_subsampling | ) |
| inlinestatic

Definition at line 613 of file ojph_params.cpp.

References VW_COLOUR_FORMAT_420, VW_COLOUR_FORMAT_422, VW_COLOUR_FORMAT_444, VW_COLOUR_FORMAT_ERROR, ojph::point::x, and ojph::point::y.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## ◆ get_gain()

float ojph::local::visual_weights::get_gain | ( | ui32 | comp_type | ) |
| inlinestatic

Definition at line 675 of file ojph_params.cpp.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## ◆ get_no_weights()

const float * ojph::local::visual_weights::get_no_weights | ( |  | ) |
| inlinestatic

Definition at line 656 of file ojph_params.cpp.

References no_weights.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## ◆ get_weight()

float ojph::local::visual_weights::get_weight | ( | const float * | v,
|  | ui32 | decomposition_level,
|  | ui32 | subband_idx )
| inlinestatic

Definition at line 659 of file ojph_params.cpp.

References ojph_min.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## ◆ get_weights()

const float * ojph::local::visual_weights::get_weights | ( | ui32 | format,
|  | ui32 | comp_type )
| inlinestatic

Definition at line 626 of file ojph_params.cpp.

References cb420, cb422, cb444, cr420, cr422, cr444, VW_COLOUR_FORMAT_420, VW_COLOUR_FORMAT_422, VW_COLOUR_FORMAT_444, and y.

Referenced by ojph::local::param_qcd::set_irrev_quant().

## Member Data Documentation

## ◆ cb420

const float ojph::local::visual_weights::cb420
| staticprivate

Initial value:
= {
0.2724f, 0.5128f, 0.5128f,
0.6692f, 0.9382f, 0.9382f,
1.0888f, 1.3046f, 1.3046f,
1.4156f, 1.5594f, 1.5594f,
2.0f, 2.0f, 2.0f,
2.0f, 2.0f, 2.0f, 2.0f}

Definition at line 727 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ cb422

const float ojph::local::visual_weights::cb422
| staticprivate

Initial value:
= {
0.1220f, 0.1220f, 0.3626f,
0.3626f, 0.3626f, 0.6634f,
0.6634f, 0.6634f, 0.9225f,
0.9225f, 0.9225f, 1.1027f,
1.1027f, 1.1027f, 1.4142f,
1.4142f, 1.4142f, 1.4142f, 1.4142f}

Definition at line 729 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ cb444

const float ojph::local::visual_weights::cb444
| staticprivate

Initial value:
= {
0.0263f, 0.0863f, 0.0863f,
0.1362f, 0.2564f, 0.2564f,
0.3346f, 0.4691f, 0.4691f,
0.5444f, 0.6523f, 0.6523f,
0.7078f, 0.7797f, 0.7797f,
1.0f, 1.0f, 1.0f, 1.0f}

Definition at line 731 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ cr420

const float ojph::local::visual_weights::cr420
| staticprivate

Initial value:
= {
0.5196f, 0.8260f, 0.8260f,
1.0080f, 1.2928f, 1.2928f,
1.4440f, 1.6508f, 1.6508f,
1.7538f, 1.8848f, 1.8848f,
2.0f, 2.0f, 2.0f,
2.0f, 2.0f, 2.0f, 2.0f}

Definition at line 728 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ cr422

const float ojph::local::visual_weights::cr422
| staticprivate

Initial value:
= {
0.2595f, 0.2595f, 0.5841f,
0.5841f, 0.5841f, 0.9141f,
0.9141f, 0.9141f, 1.1673f,
1.1673f, 1.1673f, 1.3328f,
1.3328f, 1.3328f, 1.4142f,
1.4142f, 1.4142f, 1.4142f, 1.4142f}

Definition at line 730 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ cr444

const float ojph::local::visual_weights::cr444
| staticprivate

Initial value:
= {
0.0773f, 0.1835f, 0.1835f,
0.2598f, 0.4130f, 0.4130f,
0.5040f, 0.6464f, 0.6464f,
0.7220f, 0.8254f, 0.8254f,
0.8769f, 0.9424f, 0.9424f,
1.0f, 1.0f, 1.0f, 1.0f}

Definition at line 732 of file ojph_params.cpp.

Referenced by get_weights().

## ◆ no_weights

const float ojph::local::visual_weights::no_weights
| staticprivate

Initial value:
= {
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f, 1.0f}

Definition at line 734 of file ojph_params.cpp.

Referenced by get_no_weights().

## ◆ y

const float ojph::local::visual_weights::y
| staticprivate

Initial value:
= {
0.0901f, 0.2758f, 0.2758f,
0.7018f, 0.8378f, 0.8378f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f,
1.0f, 1.0f, 1.0f, 1.0f}

Definition at line 733 of file ojph_params.cpp.

Referenced by get_weights().

The documentation for this class was generated from the following file:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_params.cpp